/*
 * ===========================
 * VDK Builder
 * Version 0.1
 * Revision 0.0
 * November 1998
 * ===========================
 *
 * Copyright (C) 1998,1999 Mario Motta
 * Developed by Mario Motta <mmotta@guest.net>
 *
 * Based on VDK Library
 * Copyright (C) 1998, Mario Motta
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 */
#include <config.h>
#include <vdkb2/vdkb_locale.h>
#include <vdkb2/vdkb_utils.h>
#include "pixmaps/newprj.xpm"
#include "pixmaps/newunit.xpm"
#include "pixmaps/newform.xpm"
#include "pixmaps/mininewform.xpm"
#include "pixmaps/loadprj.xpm"
#include "pixmaps/loadfile.xpm"
#include "pixmaps/savefile.xpm"
#include "pixmaps/saveprj.xpm"
#include "pixmaps/viewunits.xpm"
#include "pixmaps/viewforms.xpm"
#include "pixmaps/addtoprj.xpm"
#include "pixmaps/remfromprj.xpm"
#include "pixmaps/toggleformunits.xpm"
#include "pixmaps/run.xpm"
#include "pixmaps/selector.xpm"
#include "pixmaps/search.xpm"
#include "pixmaps/acsupport.xpm"
#include "pixmaps/emacs.xpm"
// container widgets pixmaps
#include "pixmaps/vbox.xpm"
#include "pixmaps/hbox.xpm"
#include "pixmaps/frame.xpm"
#include "pixmaps/table.xpm"
#include "pixmaps/vpaned.xpm"
#include "pixmaps/hpaned.xpm"
#include "pixmaps/notebook.xpm"
#include "pixmaps/handlebox.xpm"
#include "pixmaps/coolbar.xpm"
#include "pixmaps/scrolledwindow.xpm"
#include "pixmaps/menubar.xpm"
#include "pixmaps/rbgroup.xpm"
#include "pixmaps/hrbgroup.xpm"
// #include "pixmaps/packer.xpm"
#include "pixmaps/fixed.xpm"
// button widgets pixmaps
#include "pixmaps/button.xpm"
#include "pixmaps/pixbutton.xpm"
#include "pixmaps/spinbutton.xpm"
#include "pixmaps/checkbutton.xpm"
#include "pixmaps/radiobutton.xpm"
// text widget pixmaps
#include "pixmaps/label.xpm"
#include "pixmaps/entry.xpm"
#include "pixmaps/text.xpm"
// misc widgets pixmaps
#include "pixmaps/canvas.xpm"
#include "pixmaps/pixmap.xpm"
#include "pixmaps/apple.xpm"
#include "pixmaps/progressbar.xpm"
#include "pixmaps/scale.xpm"
#include "pixmaps/statusbar.xpm"
#include "pixmaps/timer.xpm"
#include "pixmaps/list.xpm"
#include "pixmaps/combo.xpm"
#include "pixmaps/hseparator.xpm"
#include "pixmaps/vseparator.xpm"
#include "pixmaps/tree.xpm"
#include "pixmaps/grid.xpm"
#include "pixmaps/ghost.xpm"
// gnome widgets pixmaps
#include "pixmaps/gnomededit.xpm"
#include "pixmaps/gnomeentry.xpm"
// dialogs widgets pixmaps
#include "pixmaps/openfiledlg.xpm"
#include "pixmaps/savefiledlg.xpm"
#include "pixmaps/colorseldialog.xpm"
#include "pixmaps/fontseldialog.xpm"
// prj man pixmaps
#include "pixmaps/new_prj_big.xpm"
#include "pixmaps/remove_big.xpm"
#include "pixmaps/activate_big.xpm"
#include "pixmaps/prj_node.xpm"
#include "pixmaps/unit_node.xpm"
#include "pixmaps/exec.xpm"
#include "pixmaps/formprops.xpm"
#include "pixmaps/edit.xpm"
// class viewer pixmaps
#include "pixmaps/addfunc.xpm"
// about dialog xpm's
#include "pixmaps/simpson1.xpm"
#include "pixmaps/simpson2.xpm"
// project wizard xpm's
#include "pixmaps/app_wiz.xpm"
#include "pixmaps/compo_wiz.xpm"
#include "pixmaps/wizard_wiz.xpm"
// maker pixmaps
#include "pixmaps/maker.xpm"
#include "pixmaps/makerkill.xpm"

// static char buffer[256];
// extern void create_nonvdk_modal_window (char* prompt);
//////////// INTERFACE PROMPTS AND PIXMAPS ////////////
// main toolbar pixmaps (upper side)
char ** main_toolbar_pixmaps[] =
{
newprj_xpm,newunit_xpm,newform_xpm,
loadprj_xpm,loadfile_xpm,saveprj_xpm,
savefile_xpm,
0
};
char ** main_toolbar1_pixmaps[] =
{
  toggleformunits_xpm,run_xpm,selector_xpm,emacs_xpm, 0
};

// main menu pixmaps
char **main_menu_pixmaps[] =
{
  newprj_xpm,newunit_xpm,newform_xpm, //0 1 2
  loadprj_xpm,loadfile_xpm, // 3 4
  savefile_xpm,saveprj_xpm, // 5 6
  viewunits_xpm,viewforms_xpm, // 7 8
  addtoprj_xpm,remfromprj_xpm, // 9 10
  search_xpm,acsupport_xpm, //11 12
0
};
// container widgets pixmaps
char **container_widgets_pixmaps[] =
{
  vbox_xpm,hbox_xpm,frame_xpm, // 0 1 2
  table_xpm,vpaned_xpm,hpaned_xpm, // 3 4 5
  notebook_xpm,handlebox_xpm,coolbar_xpm,  // 6 7 8
  scrolledwindow_xpm, menubar_xpm, rbgroup_xpm, // 9 10 11
  hrbgroup_xpm, /*packer_xpm, */ fixed_xpm //12 13 
};
// button widgets pixmaps
char **button_widgets_pixmaps[] =
{
  button_xpm,spinbutton_xpm,checkbutton_xpm, // 0 1 2 
  radiobutton_xpm // 3
};
// text widgets pixmaps
char **text_widgets_pixmaps[] =
{
  label_xpm,entry_xpm,text_xpm // 0 1 2
};
// misc widgtes pixmpas
// used by VDKBPixmap gui object in vdkb_pixmap.cc
char** default_pixmap = pixmap_xpm;
char **misc_widgets_pixmaps[] =
{
  canvas_xpm,pixmap_xpm,apple_xpm,progressbar_xpm, // 0 1 2 3
  scale_xpm,statusbar_xpm,timer_xpm, //  4 5 6
  list_xpm,combo_xpm,tree_xpm, //  7 8 9
  hseparator_xpm, vseparator_xpm, //  10 11
  ghost_xpm // grid_xpm, tree_xpm  12  
};

// gnome widgets pixmaps
char **gnome_widgets_pixmaps[] =
{
  statusbar_xpm,gnomededit_xpm,gnomeentry_xpm  // 0 1 2
};

// xdb widgets pixmaps
char **xdb_widgets_pixmaps[] =
{
  entry_xpm,list_xpm,checkbutton_xpm,text_xpm  // 0 1 2 3
};

// dlg widgets pixmaps
char **dlg_widgets_pixmaps[] =
{
  openfiledlg_xpm,openfiledlg_xpm,savefiledlg_xpm, // 0 1 2
  colorseldialog_xpm,fontseldialog_xpm // 3 4
};
//////////////////// PRJMAN /////////////////
char **prjman_pixmaps[] =
{
  NULL,newprj_xpm,addtoprj_xpm, // 0 1 2
  remfromprj_xpm,edit_xpm, // 3 4
  form_props_xpm,addfunc_xpm, // 5 6
  form_props_xpm,activate_big_xpm, // 7 8 -- needs images for cv
  maker_xpm // 9 
};
///////////////////////////////////
// locale parser routines
///////////////////////////////////
void
LoadInternational(int language, char* home)
{
}

/*
 */
void
FreeInternational()
{
}







